/*  Tietorakenteet ja algoritmit 1999
    Määritelmästä 4-2 : Joukon läpikäynti

	Tässä joukon toteutuksessa läpikäynti sattuu olemaan
	suuruusjärjestyksessä, mutta mitään takeita ei ole, 
	että jos toteutusta muutetaan, uusi toteutus hakisi 
	alkiot samassa järjestyksessä.

	Tehdään 14 kokonaisluvun joukko ja tulostetaan se.

    9.9.1999 MM
*/

#include "TRA.h"
#include <stdio.h>

int main() {
	/* Joukkoon vietävät luvut: */
	int Numerot [] = { 10, 85, 15, 70, 20, 60, 30, 
		               50, 65, 80, 90, 40, 5, 55 };
	DSET DS;
	DSET_ITERATOR i;
	int x;

	INT_DSET_CREATE(DS);
	for (x=0; x<14; x++) IDS_INSERT(DS, Numerot[x]);
	
	x = IDS_ANY(DS, i); /* Haetaan x:ään mikä tahansa alkio */
	while (IDS_ITERATING(DS, i)) { 
		printf("%d ", x); /* Tulostetaan alkio */	
		x = IDS_ANOTHER(DS, i); /* Valitaan jokin muu alkio */
	}
	putchar('\n');
}
